function DrawArea( _paper, _xmlAnim, _frameStart, _frameEnd, _rectangle, _doneButton, _clearButton, _zoomCont ) {
	var paper = _paper;
	var xmlAnim = _xmlAnim;
	var frameStart = _frameStart;
	var frameEnd = _frameEnd;
	var rectangle = _rectangle;
	var animPaused = false;
	var doneButton = _doneButton;
	var firstDraw = false;
	var clearButton = _clearButton;
	
	var curFrame = 0;
		
	var screenWidth = 900;
	var screenHeight = 900;
	var rect;
	var curPath;
	var pathGroup;
	var waitToAnimate = new Array();
	var stickmen = new Array();
	var mousPosX;
	var mousPosY;
	var drawStr = "";
	var currentlyDrawing = false;
	var itemIsKey = false;
	var itemIsEgg = false;
	var itemIsSword = false;
	var itemIsCloud = false;
	var itemIsDrain = false;
	var color = "#555";
	var strokeWidth = 3;
	var zoomCont = _zoomCont;
	var drawingMode = false;
	
	var finishFunction = null;

	this.setXMLAnim = function( _xmlAnim ){
		xmlAnim = _xmlAnim;
	}

	this.animateFrame = function( numFramesToAnimate ){
		if (animPaused == true) return;
		
		for (var i = 0; i < numFramesToAnimate; i++) {
			if (curFrame == frameStart) {
				setupDrawArea();
			}
			else if (curFrame == frameEnd) {
	//			xmlAnim.pauseAnimation();
				xmlAnim.pauseAll();
				curFrame ++;
				//console.log("draw area f = " + curFrame);
				return;
			}
		
			curFrame ++;
			//console.log("draw area f = " + curFrame);
			if (curFrame >= frameStart && curFrame <= frameEnd) {
				return i + 1;
			}
		}
		

		return numFramesToAnimate;
	}
	
	this.pauseAnimation = function(){
		animPaused = true;
		//alert ("pause animation");
		var doneButtonClip = doneButton.getImage();
//		doneButtonClip.hide();
//		console.log("draw area pauseAnimation");
	}
	this.resumeAnimation = function(){
		if (curFrame < frameEnd) {
			//console.log("draw area resumeAnimation");
			animPaused = false;
		}
	}
	
	this.drawAsKey = function() {
		itemIsKey = true;
	}
	this.drawAsEgg = function() {
		itemIsEgg = true;
	}
	this.drawAsCloud = function() {
		itemIsCloud = true;
	}
	this.drawAsSword = function() {
		itemIsSword = true;
	}
	this.drawAsDrain = function() {
		itemIsDrain = true;
	}
	
	this.setDrawFinishedFunction = function( _finishFunction ) {
		finishFunction = _finishFunction;
	}
	
	this.setDrawColor = function (_color) {
		color = _color;
	}
	this.setStrokeWidth = function ( _strokeWidth ) {
		strokeWidth = _strokeWidth;
	}
	
		var mouseX = function(evt) {
			if (evt.pageX) return evt.pageX;
			else if (evt.clientX)
			   return evt.clientX + (document.documentElement.scrollLeft ?
			   document.documentElement.scrollLeft :
			   document.body.scrollLeft);
			else return null;
		}
		var mouseY = function(evt) {
			if (evt.pageY) return evt.pageY;
			else if (evt.clientY)
			   return evt.clientY + (document.documentElement.scrollTop ?
			   document.documentElement.scrollTop :
			   document.body.scrollTop);
			else return null;
		}
		
		var startAnimation = function() {
			if (pathGroup.findFeet() == true) {
				var stickman = new Stickman(pathGroup, paper);
				xmlAnim.setStickman( stickman );
			}
			removeDrawArea();
			xmlAnim.resumeAnimation();
		}
		
		this.cleanUp = function() {
			if (drawingMode == true) {
				if (rect != null) rect.remove();
				if (firstDraw == false) {
					var doneButtonClip = doneButton.getImage();
					doneButtonClip.unclick( doneButtonDown );
					doneButtonClip.unmouseover( doneButtonOver );
					doneButtonClip.unmouseout( doneButtonOut );
					var clearButtonClip = clearButton.getImage();
					clearButtonClip.unclick( clearButtonDown );
					clearButtonClip.unmouseover( doneButtonOver );
					clearButtonClip.unmouseout( doneButtonOut );
				}
				document.onmousedown = null;
				drawingMode = false;
				removeDrawArea();
			}
		}
		
		var removeDrawArea = function() {
			try {
				document.removeEventListener("touchstart", touchHandler, false);
				document.removeEventListener("touchmove", touchHandler, false);
				document.removeEventListener("touchend", touchHandler, false);
				document.removeEventListener("touchcancel", touchHandler, false);
			}catch(e) {
			}
		}
		
		var dragDraw = function (dx, dy) {
			var posX = zoomCont.unzoomX( mousPosX + dx );
			var posY = zoomCont.unzoomY( mousPosY + dy );
			mousePosX = posX;
			mousePosY = posY;
			drawAtPoint(posX, posY);
		}
		
		var drawAtPoint = function (posX, posY) {
      if (curPath != null){
        if (rectangle.isPointWithinRect( posX, posY ) == true ) {
          curPath.quickDrawNode(Math.round( posX ), Math.round( posY ) );
        }
      }
		}
		var startDraw = function (event) {
      // trace("startDraw");
			curPath = new Path(paper, color, strokeWidth, zoomCont);
			if (firstDraw == true) {
				firstDraw = false;
				xmlAnim.resumeAnimation();
        if (!G.isAndroid){
          var doneButtonClip = doneButton.getImage();
          doneButtonClip.click( doneButtonDown );
          doneButtonClip.mouseover( doneButtonOver );
          doneButtonClip.mouseout( doneButtonOut );

          var clearButtonClip = clearButton.getImage();
          clearButtonClip.click( clearButtonDown );
          clearButtonClip.mouseover( doneButtonOver );
          clearButtonClip.mouseout( doneButtonOut );
        }
			}
		}
		var clearButtonDown = function(event) {
			if (curPath == null) return;
			pathGroup.clearDisplay();
      var doneButtonClip = doneButton.getImage();
      var clearButtonClip = clearButton.getImage();
      doneButtonClip.unclick( doneButtonDown );
      doneButtonClip.unmouseover( doneButtonOver );
      doneButtonClip.unmouseout( doneButtonOut );
      
      clearButtonClip.unclick( clearButtonDown );
      clearButtonClip.unmouseover( doneButtonOver );
      clearButtonClip.unmouseout( doneButtonOut );
      document.body.style.cursor = "default";
      curPath = null;
		}
		
		var doneButtonDown = function(event) {
			if (curPath == null) return;
      // trace("donebuttondown");
      
			// Remove the listeners
      if (!G.isAndroid){
        var doneButtonClip = doneButton.getImage();
        doneButtonClip.unclick( doneButtonDown );
        doneButtonClip.unmouseover( doneButtonOver );
        doneButtonClip.unmouseout( doneButtonOut );
        var clearButtonClip = clearButton.getImage();
        clearButtonClip.unclick( clearButtonDown );
        clearButtonClip.unmouseover( doneButtonOver );
        clearButtonClip.unmouseout( doneButtonOut );
      }
			
			document.body.style.cursor = 'default';
			if (itemIsKey == true) {
				xmlAnim.setKey( pathGroup );
				removeDrawArea();
				xmlAnim.resumeAnimation();
			}
			else if (itemIsEgg == true) {
				xmlAnim.setEgg( pathGroup );
				removeDrawArea();
				xmlAnim.resumeAnimation();
			}
			else if (itemIsSword == true) {
				xmlAnim.setSword( pathGroup );
				removeDrawArea();
				xmlAnim.resumeAnimation();
			}
			else if (itemIsCloud == true) {
				xmlAnim.setCloud( pathGroup );
				removeDrawArea();
				xmlAnim.resumeAnimation();
			}
			else if (itemIsDrain == true) {
				xmlAnim.drainDrawn( pathGroup );
				removeDrawArea();
				xmlAnim.resumeAnimation();
			}
			else {
				startAnimation();
			}
      curPath = null;
		}
		var doneButtonOver = function(event) {
			document.body.style.cursor = 'pointer';
		}
		var doneButtonOut = function(event) {
			document.body.style.cursor = 'default';
		}
		
		var stopDraw = function (event) {
			if (curPath == null) return;
      // trace("stopDraw");
			if (curPath.getNumNodes() > 0) {
				curPath.finalizePath();
				pathGroup.addPath( curPath );

				if (rect != null) {
					rect.toFront();
					var doneButtonClip = doneButton.getImage();
					doneButtonClip.toFront();
					var clearButtonClip = clearButton.getImage();
					clearButtonClip.toFront();
				}
				curPath = new Path(paper, color, strokeWidth, zoomCont );
			}
		}
		
		var touchHandler = function(e) {
      if (G.popup){
        return;
      }
      if (e.type == "touchend" || e.type == "touchcancel") {
				if (currentlyDrawing == true) {
					stopDraw();
					e.preventDefault();
				}
			}
      else{
        var offset = $("#holder").offset();
        offsetX = offset.left;
				offsetY = offset.top - $(window).scrollTop();

				mousePosX = zoomCont.unzoomX( e.touches[0].pageX - offsetX );
				mousePosY = zoomCont.unzoomY( e.touches[0].pageY - offsetY );
        if (e.type == "touchstart") {
          // mousePosX = e.touches[0].clientX - offset.left;
          // mousePosY = e.touches[0].clientY - offset.top;
          
          // Check if the user touched the done button
          var doneBounds = doneButton.getBoundsNoZoom();
          var clearBounds = clearButton.getBoundsNoZoom();
          
          if (doneBounds.isPointWithinRect( mousePosX, mousePosY ) == true ) {
            doneButtonDown();
          }
          else if (clearBounds.isPointWithinRect( mousePosX, mousePosY ) == true ) {
            clearButtonDown();
          }
          else {
            if (rectangle.isPointWithinRect( mousePosX, mousePosY ) == true ) {
              stopDraw();
              startDraw();
              drawAtPoint(mousePosX, mousePosY);
              currentlyDrawing = true;
              e.preventDefault();
            }
            else {
              currentlyDrawing = false;
            }
          }
        }
        else if (e.type == "touchmove") {
          if (currentlyDrawing == true) {
            drawAtPoint(mousePosX, mousePosY);
            e.preventDefault();
          }
        }
      }
		}

		var setupDrawArea = function () {
			xmlAnim.pauseAll();

			//alert ("setup draw Area");
			firstDraw = true;
			drawingMode = true;
			pathGroup = new PathGroup( paper, zoomCont );
			rect = paper.rect(0,0, paper.width, paper.height, 0).attr({'fill':'#f00', opacity:0});
      if (!G.isAndroid){
        rect.drag(dragDraw, startDraw, stopDraw);
      }
      document.onmousedown = mouseDown;
			try {
				document.addEventListener("touchstart", touchHandler, false);
				document.addEventListener("touchmove", touchHandler, false);
				document.addEventListener("touchend", touchHandler, false);
				document.addEventListener("touchcancel", touchHandler, false);
			}catch(e) {
			}
		};
		

		function mouseMove(ev){
		  ev = ev || window.event;
			mousPosX = mouseX(ev);
			mousPosY = mouseY(ev);
		} 
		
		function mouseDown(ev){
		  ev = ev || window.event;
			var offset = $("#holder").offset();
			mousPosX = mouseX(ev) - offset.left;
			mousPosY = mouseY(ev) - offset.top;
		} 
		function mouseUp(ev){ 
		  document.onmousemove = null;
			document.onmouseup = null; 
      stopDraw(ev);
		} 
}