function PathGroup(_paper, _zoomCont) {
	var paths = new Array();
	var paper = _paper;
	var lineOnScreen;
	var rect;
	var distortion;
	var leftFootNode;
	var rightFootNode;
	var offsetX = 0;
	var offsetY = 0;
	var lockedX;
	var lockedY;
	var lockedNode;
	var headPos;
	var feetPos;
	var numPaths = 0;
	var heldItems = new Array();
	var heldItemPos = new Array();
	var numHeldItems = 0;
	var zoomX = 0;
	var zoomY = 0;
	var zoomScaleX = 1;
	var zoomScaleY = 1;
	var pathGroupObj = this;
	
	var eggSpeedY = 0;
	var eggGravity = 1;
	var eggBottomY;
	var eggGround;
	var eggNodes = new Array();
	var numEggNodes = 0;
	var eggRowNodes;
	var eggRowHeight;
	var lastDeleteRow;
	
	// Rain drops
	var rainDropSpeeds = new Array();
	var rainDrops = new Array();
	var rainDropX = new Array();
	var rainDropY = new Array();
	var numDrops = 0;
	var waterLevel = 560;
	var maxNumDrops = 50;
	var rainFrame = 0;
	var waterRiseSpeed = -1.6;
	var waterRiseFrame = 340;
	var cloudStickman;
	var cloudStickmanY = 610;
	var waterLevelMax = 170;
	var swimFrame = 400;
	var swimBob = 0;
	var cloudBottom = 0;
	
	// Slow draw
	var lastSlowPathDrawn;
	var doneDrawingFunction;
	
	// Hat
	var hatFallSpeedX;
	var hatFallSpeedY;
	var hatDestinationY;
	var hatGravity;
	var hatAnimFinishedFunction;
	var hatTop;
	var hatPaths;
	var numHatPaths;
	var externalPaths = new Array();
	var numExternalPaths = 0;
	var alwayAtBack = false;
	var zoomCont = _zoomCont;
	
	this.findIndexOf = function(arrayObj, obj) {
		if(!Array.indexOf){
			for(var i=0; i<arrayObj.length; i++){
				if(arrayObj[i]==obj){
					return i;
				}
			}
			return -1;
		}
		else {
			return arrayObj.indexOf( obj );
		}
	}
	var addPath = this.addPath = function(_path) {
		paths.push( _path );
		numPaths ++;
		if (rect == null) {
			rect = _path.getRect();
		} else {
			if (_path.getRect() != null) {
				rect.addRectangle( _path.getRect() );
			}
		}
		distortion = new Distortion( rect );
	}
	
	this.findSecondFoot = function(firstFoot, checkDist) {
//		alert ("looking for second foot");
		//var checkDist = 10;
		var line = new Line(firstFoot.getX());
		var legNodes = new Array();
		legNodes.push( firstFoot );

		// Climb from the bottom row to the top row looking for isolated nodes
		for (var rowBottom = firstFoot.getY(); rowBottom > rect.top; rowBottom -= checkDist) {
			var rowTop = rowBottom - checkDist;
			
			var nodesInRow = new Array();
			// Find nodes in this row
			for (i in paths) {
				var newNodesInRow = paths[i].getNodesInRow(rowTop, rowBottom);
				for (var n in newNodesInRow) {
					nodesInRow.push( newNodesInRow[n] );
				}
			}
			// Find if there is an isolated node in this row
			var foundNearbyNode = true;
			var usedNodes = new Array();
//			alert ("nodesInRow.length = " + nodesInRow.length + " usedNodes.length = " + usedNodes.length + "rowBottom = " + rowBottom + " rect.top = " + rect.top);
			for (var t = 0; t < nodesInRow.length; t++) {
				foundNearbyNode = false;
				for (i in nodesInRow) {
					if (this.findIndexOf(usedNodes, nodesInRow[i]) == -1) {
						if (line.isNearLine( nodesInRow[i].getX(), checkDist ) == true) {
							line.addPoint( nodesInRow[i].getX() );
							usedNodes.push( nodesInRow[i] );
							foundNearbyNode = true;
						}
					}
				}
				if (foundNearbyNode == false) {
					// Found an isolated node. This is the other foot
					for (i in nodesInRow) {
						if (this.findIndexOf(usedNodes, nodesInRow[i]) == -1) {
//							alert ("found second foot");
							return nodesInRow[i];
						}
					}
				}
			}
		}
		// No foot found
//		alert("second foot not found");
		return null;
	}
				
				
				
	this.findFeet = function() {
		var lowestNode = paths[0].getLowestNode();
		var lowestPath = paths[0];
		// Find the first foot
		for (var i = 0; i < numPaths; i++) {
			var newLowestNode = paths[i].getLowestNode();
			if (newLowestNode == null) {
				var nullNode = 1;
			}
			else {
				if (newLowestNode.getY() > lowestNode.getY()) {
					lowestNode = newLowestNode;
					lowestPath = paths[i];
				}
			}
		}
		var secLowestNode = this.findSecondFoot( lowestNode, 10 );
		
		// Can't find the second foot.
		if (secLowestNode == null) {
			secLowestNode = this.findSecondFoot( lowestNode, 5 );
			if (secLowestNode == null) {
				secLowestNode = this.findSecondFoot( lowestNode, 1 );
				if (secLowestNode == null) {
					return false;
				}
			}
		}
		
		// Second foot found
		if (lowestNode.getX() < secLowestNode.getX()) {
			leftFootNode = lowestNode;
			rightFootNode = secLowestNode;
		}
		else {
			rightFootNode = lowestNode;
			leftFootNode = secLowestNode;
		}
		
		headPos = new Point( rect.getCenterX(), rect.top );
		feetPos = new Point( rect.getCenterX(), rect.bottom );
		

		return true;
	}
	
	this.lockLeftFoot = function() {
		lockedNode = leftFootNode;
		lockedX = distortion.distortPointX( leftFootNode.getX(), leftFootNode.getY() ) + offsetX;
		lockedY = distortion.distortPointY( leftFootNode.getX(), leftFootNode.getY() ) + offsetY;
	}
	this.lockRightFoot = function() {
		lockedNode = rightFootNode;
		lockedX = distortion.distortPointX( rightFootNode.getX(), rightFootNode.getY() ) + offsetX;
		lockedY = distortion.distortPointY( rightFootNode.getX(), rightFootNode.getY() ) + offsetY;
	}
	this.translateLockedPos = function(transX, transY) {
		lockedX += transX;
		lockedY += transY;
	}
	this.setLockedPosOnScreen = function(posOnScreenX, posOnScreenY) {
		lockedX = (posOnScreenX - zoomX) / zoomScaleX;
		lockedY = (posOnScreenY - zoomY) / zoomScaleY;
	}
	this.setLockedPosOnScreenX = function(posOnScreenX) {
		lockedX = (posOnScreenX - zoomX) / zoomScaleX;
	}
	this.setLockedPosOnScreenY = function(posOnScreenY) {
		lockedY = (posOnScreenY  - zoomY) / zoomScaleY;
	}
	this.getLockedPosOnScreenX = function() {
		return (lockedX) * zoomScaleX + zoomX;
	}
	this.getLockedPosOnScreenY = function() {
		return (lockedY) * zoomScaleY + zoomY;
	}
	
	var updatePosition = this.updatePosition = function () {
		if (lockedNode != null) {
			var footNodeX = distortion.distortPointX( lockedNode.getX(), lockedNode.getY() );
			var footNodeY = distortion.distortPointY( lockedNode.getX(), lockedNode.getY() );
			offsetX = lockedX - footNodeX;
			offsetY = lockedY - footNodeY;
		}
	}
	
	this.draw = function() {
		updatePosition();
		for (var i = 0; i < numPaths; i++) {
			paths[i].draw( distortion, offsetX, offsetY);
		}
		for (i = 0; i < numHeldItems; i++) {
			var itemX = distortion.distortPointX( heldItemPos[i].x, heldItemPos[i].y );
			var itemY = distortion.distortPointY( heldItemPos[i].x, heldItemPos[i].y );
			heldItems[i].centerOnPos( new Point( (itemX + offsetX) * zoomScaleX + zoomX, (itemY + offsetY) * zoomScaleY + zoomY ) );
			heldItems[i].draw();
		}
		if (alwayAtBack == true) {
			sendToBack();
		}
	}
	this.getDistortion = function() {
		return distortion;
	}
	this.highlightFeet = function() {
		var leftFootHighlight = paper.circle(leftFootNode.getX(),leftFootNode.getY(), 5, 5, 0).attr({'fill':'#f00', opacity:.5});
		var rightFootHighlight = paper.circle(rightFootNode.getX(),rightFootNode.getY(), 5, 5, 0).attr({'fill':'#0f0', opacity:.5});
//		for (var i in paths) {
//			paths[i].highlightNodes();
//		}
	}
	this.getHeadPosition = function() {
		var pos = new Point(headPos.x + offsetX, headPos.y + offsetY );
		return pos;
	}
	
	this.getFeetPosition = function() {
		var pos = new Point( (feetPos.x + offsetX) * zoomScaleX + zoomX, (feetPos.y + offsetY) * zoomScaleY + zoomY );
		return pos;
	}
	this.getTopPos = function() {
		return (rect.top + offsetY) * zoomScaleY + zoomY;
	}
	this.getCenterPos = function() {
		return new Point( rect.getCenterX(), rect.getCenterY() );
	}
	this.getCenterPosWithOffset = function() {
		return new Point( rect.getCenterX() + offsetX, rect.getCenterY() + offsetY );
	}
	
	this.centerOnPos = function( newPos ) {
		//if (rect == null) {
		//	rect = paths[0].getRect();
		//}
		offsetX -= rect.getCenterX() + offsetX - newPos.x;
		offsetY -= rect.getCenterY() + offsetY - newPos.y;
	}
	
	this.translate = function( translateX, translateY ) {
		//console.log("translateX = " + translateX);
		//console.log("translateY = " + translateY);
		offsetX += translateX;
		offsetY += translateY;
	}
	
	this.getHeight = function() {
		return rect.bottom - rect.top;
	}
	
	var setScale = this.setScale = function( _posX, _posY, _scaleX, _scaleY ) {
		zoomX = _posX;
		zoomY = _posY;
		zoomScaleX = _scaleX;
		zoomScaleY = _scaleY;
		
		for (var i = 0; i < numPaths; i++) {
			paths[i].setScale( _posX, _posY, _scaleX, _scaleY );
		}
		for (i = 0; i < numHeldItems; i++) {
			heldItems[i].setScale( _posX, _posY, _scaleX, _scaleY );
		}
	}
	
	this.holdPathGroup = function( item ) {
		heldItems.push( item );
		var centerPos = item.getCenterPos();
		centerPos.x = (centerPos.x - zoomX) / zoomScaleX - offsetX;
		centerPos.y = (centerPos.y - zoomY) / zoomScaleY - offsetY;
		heldItemPos.push( centerPos );
		numHeldItems ++;
	}
	
	this.stopHoldingItem = function( item ) {
		heldItems = new Array();
		heldItemPos = new Array();
		numHeldItems = 0;
		// Had to get rid of this to work in IE
		//var i = this.findIndexOf(heldItems, item);
		//heldItems.splice(i);
		//heldItemPos.splice(i);
		//numHeldItems --;
	}
	
	this.convertGlobalPointToRelative = function( globalPoint ) {
		var relative = new Point( global.x - offsetX, global.y - offsetY );
		return relative;
	}
	
	// Returns the needed info to make the stickman move an item he is holding to a specified point on his left.
	this.makeReachLeftDistortion = function( item, destPoint ) {
		var destPos = new Point( destPoint.x - offsetX, destPoint.y - offsetY );
		var i = this.findIndexOf( heldItems, item );
		var itemPos = heldItemPos[i];
		
		var scaleX = ((rect.right - destPos.x) / (rect.right - itemPos.x) ) * ((rect.bottom - itemPos.y) / (rect.bottom - rect.top));
		var scaleY = ((rect.bottom - destPos.y) / (rect.bottom - itemPos.y) ) * ((rect.right - itemPos.x) / (rect.right - rect.left));
		
		//paper.circle(destPos.x, destPos.y, 5, 5, 0).attr({'fill':'#f00', opacity:.5});
		//paper.circle(itemPos.x, itemPos.y, 5, 5, 0).attr({'fill':'#0f0', opacity:.5});

		return new Point( scaleX, scaleY );
	}
		
	// Returns the needed info to make the stickman move an item he is holding to a specified point on his right.
	this.makeReachRightDistortion = function( item, destPoint ) {
		var destPos = new Point( destPoint.x - offsetX, destPoint.y - offsetY );
		var i = this.findIndexOf( heldItems, item );
		var itemPos = heldItemPos[i];
		
		var scaleX = ((destPos.x - rect.left) / (itemPos.x - rect.left) ) * ((rect.bottom - itemPos.y) / (rect.bottom - rect.top));
		var scaleY = ((rect.bottom - destPos.y) / (rect.bottom - itemPos.y) ) * ((itemPos.x - rect.left) / (rect.right - rect.left));
		
		//paper.circle(destPos.x, destPos.y, 5, 5, 0).attr({'fill':'#f00', opacity:.5});
		//paper.circle(itemPos.x, itemPos.y, 5, 5, 0).attr({'fill':'#0f0', opacity:.5});

		return new Point( scaleX, scaleY );
	}
	
	// Move foot to point.
	this.makeRightFootDistortion = function( footLockedPos, destPoint ) {
		var rectTL = new Point( footLockedPos.x - (leftFootNode.getX() - rect.left) * zoomScaleX, footLockedPos.y - (leftFootNode.getY() - rect.top) * zoomScaleY );
		var destPos = convertPointToScaleTarget( destPoint.x, destPoint.y, rectTL );
		var mobileFt = convertPointToScaleTarget( rectTL.x + (rightFootNode.getX() - rect.left) * zoomScaleX, rectTL.y + (rightFootNode.getY() - rect.top) * zoomScaleY, rectTL );
		var fixedFt = convertPointToScaleTarget( footLockedPos.x, footLockedPos.y, rectTL );
		
		//F1 = fixedFt
		//F2 = mobileFt
		
		var brCornerX = 1 + (1-fixedFt.x) * (destPos.x-mobileFt.x) / (((1-fixedFt.x) * mobileFt.x - fixedFt.x * (1-mobileFt.x)) * mobileFt.y);
		var blCornerX = -fixedFt.x * (brCornerX-1) / (1-fixedFt.x);
		
		var brCornerY = 1 + (1-fixedFt.x) * (destPos.y-mobileFt.y) / (((1-fixedFt.x) * mobileFt.x - fixedFt.x * (1-mobileFt.x)) * mobileFt.y)
		var blCornerY = 1 - fixedFt.x * (brCornerY-1) / (1-fixedFt.x);

		

		var brCornerPoint = new Point( brCornerX, brCornerY );
		var blCornerPoint = new Point( (1 - blCornerX), blCornerY );
		//paper.circle(destPos.x, destPos.y, 5, 5, 0).attr({'fill':'#f00', opacity:.5});
		//paper.circle(itemPos.x, itemPos.y, 5, 5, 0).attr({'fill':'#0f0', opacity:.5});

		var corners = new Array( blCornerPoint, brCornerPoint );
		return corners;
	}
	this.makeLeftFootDistortion = function( footLockedPos, destPoint ) {
		var rectTL = new Point( footLockedPos.x - (rightFootNode.getX() - rect.left) * zoomScaleX, footLockedPos.y - (rightFootNode.getY() - rect.top) * zoomScaleY );
		var destPos = convertPointToScaleTarget( destPoint.x, destPoint.y, rectTL );
		var mobileFt = convertPointToScaleTarget( rectTL.x + (leftFootNode.getX() - rect.left) * zoomScaleX, rectTL.y + (leftFootNode.getY() - rect.top) * zoomScaleY, rectTL );
		var fixedFt = convertPointToScaleTarget( footLockedPos.x, footLockedPos.y, rectTL );
		
		//F1 = mobileFt
		//F2 = fixedFt
		
		
		var blCornerX = (fixedFt.x * (destPos.x - mobileFt.x)) / (((1-mobileFt.x) * fixedFt.x - mobileFt.x * (1-fixedFt.x)) * mobileFt.y);
		var brCornerX = 1 - (blCornerX * (1-fixedFt.x)) / fixedFt.x;
		
		var blCornerY = 1 + fixedFt.x * (destPos.y - mobileFt.y) / (((1-mobileFt.x) * fixedFt.x - (1-fixedFt.x) * mobileFt.x) * mobileFt.y);
		var brCornerY = 1 - ((blCornerY-1) * (1-fixedFt.x)) / fixedFt.x;

		
		
		var brCornerPoint = new Point( brCornerX, brCornerY );
		var blCornerPoint = new Point( (1 - blCornerX), blCornerY );
		//paper.circle(destPos.x, destPos.y, 5, 5, 0).attr({'fill':'#f00', opacity:.5});
		//paper.circle(itemPos.x, itemPos.y, 5, 5, 0).attr({'fill':'#0f0', opacity:.5});

		var corners = new Array( blCornerPoint, brCornerPoint );
		return corners;
	}
	
	// Converts a point to be used for moving the foot distortion.
	var convertPointToScaleTarget = function( pX, pY, rectTL ) {
		var scaleTargetX = ((pX - rectTL.x ) /  zoomScaleX) / rect.getWidth();
		var scaleTargetY = ((pY - rectTL.y ) /  zoomScaleY) / rect.getHeight();
		
		return new Point( scaleTargetX, scaleTargetY );
	}




	this.setupEggFall = function( _eggGround ) {
		eggGround = _eggGround;
		//paper.circle(100, eggGround, 5, 5, 0).attr({'fill':'#f00', opacity:.5});
		//alert("eggGround = " + eggGround);
		findEggBottom( 10 );
	}
	
	var findEggBottom = function( checkDist ) {
		var rowWidths = new Array();
		var widestRowWidth = 0;
		var widestRowIndex = 0;
		var narrowestRowWidth = 1000;
		var narrowestRowIndex = 0;
		var rowNum = 0;
		var rowNodes = new Array();
		
		for (var rowBottom = rect.top + checkDist; rowBottom <= rect.bottom + checkDist; rowBottom += checkDist) {
			var rowTop = rowBottom - checkDist;
			
			var nodesInRow = new Array();
			var rowLine = null;
			// Find nodes in this row
			for (var i in paths) {
				var newNodesInRow = paths[i].getNodesInRow(rowTop, rowBottom);
				
				for (var n in newNodesInRow) {
					nodesInRow.push( newNodesInRow[n] );
					if (rowLine == null) rowLine = new Line( nodesInRow[n].getX() );
					else rowLine.addPoint( nodesInRow[n].getX() );
				}
			}
			// Find the widest row
			if (rowLine != null) {
				var newWidth = rowLine.getLength();
				if (newWidth >= widestRowWidth) {
					widestRowWidth = newWidth;
					widestRowIndex = rowNum;
				}
				if (newWidth < narrowestRowWidth && newWidth > 0) {
					narrowestRowWidth = newWidth;
					narrowestRowIndex = rowNum;
				}
			}
			
			rowWidths.push( newWidth );
			rowNodes.push( nodesInRow );
			
			rowNum ++;
		}
		
		var numRows = rowNum;
		var eggBottomRowIndex = widestRowIndex;
		
		for (i = widestRowIndex; i < numRows; i++) {
			if (rowWidths[i] <= narrowestRowWidth + 10) {
				eggBottomRowIndex = i;
				break;
			}
		}
		
		// Delete the nodes below the bottom of the egg
		//for (i = eggBottomRowIndex; i < numRows; i++) {
		//	var nodes = rowNodes[i];
		//	var numNodes = nodes.length;
		//	for (n = 0; n < numNodes; n++) {
		//		nodes[n].markForDelete();
		//	}
		//}
		
		for (i = 0; i < eggBottomRowIndex; i++) {
			nodes = rowNodes[i];
			numNodes = nodes.length;
			for (n = 0; n < numNodes; n++) {
				if (pathGroupObj.findIndexOf( eggNodes, nodes[n] ) == -1) {
					eggNodes.push( nodes[n] );
					numEggNodes ++;
				}
			}
		}
		eggBottomY = (eggBottomRowIndex + 1) * checkDist + offsetY + rect.top;
		eggRowNodes = rowNodes;
		eggRowHeight = checkDist;
		lastDeleteRow = eggBottomRowIndex;
		
		//console.log("eggBottomRowIndex = " + eggBottomRowIndex);
		//console.log("numRows = " + numRows);
		//console.log("widestRowIndex = " + widestRowIndex);
		//console.log("narrowestRowWidth = " + narrowestRowWidth);
		//console.log("eggBottomRowIndex = " + eggBottomRowIndex);
		
		//removeDeletedNodes();
		//pathGroupObj.draw();
	}
	
	var removeDeletedNodes = function() {
		for (var i = 0; i < numPaths; i++) {
			paths[i].removeDeletedNodes();
		}
	}
	
	this.animateEgg = function( numFramesToAnimate ) {
		for (var f = 0; f < numFramesToAnimate; f++) {
			var animFinished = false;
			
			eggSpeedY += eggGravity;
			eggBottomY += eggSpeedY;
			//console.log("eggSpeedY = " + eggSpeedY);
			//console.log("eggBottomY = " + eggBottomY);
			//console.log("eggGround = " + eggGround);
			//console.log("offsetY = " + offsetY);
			//console.log("zoomY = " + zoomY);
			//console.log("zoomScaleY = " + zoomScaleY);
			if (eggBottomY > eggGround) {
				eggSpeedY -= eggBottomY - eggGround;
				eggBottomY = eggGround;
				animFinished = true;
			}
			for (var i = 0; i < numEggNodes; i++) {
				eggNodes[i].move(0, eggSpeedY);
			}
			
			// Delete nodes as egg covers them
			rowToDelete = Math.round( (eggBottomY - rect.top) / eggRowHeight);
			if (rowToDelete >= eggRowNodes.length) rowToDelete = eggRowNodes.length - 1;
			for (i = lastDeleteRow; i <= rowToDelete; i++) {
				var nodes = eggRowNodes[i];
				var numNodes = nodes.length;
				for (n = 0; n < numNodes; n++) {
					nodes[n].markForDelete();
				}
			}
			lastDeleteRow = rowToDelete;
			removeDeletedNodes();
		}
		
		pathGroupObj.draw();
		
		return animFinished;
	}
		
	this.clearDisplay = function() {
		for (var i = 0; i < numPaths; i++) {
			paths[i].clearDisplay();
		}
		paths = new Array();
		numPaths = 0;
		rect = null;
	}
	
	this.setupRainCloud = function( stickman ) {
		cloudStickman = stickman;
		
		cloudBottom = findCloudBottom( 20 );
	}
	
	this.animateRain = function( numFramesToAnimate ) {
		var oldY;
		for (var f = 0; f < numFramesToAnimate; f++) {
			// Create a new rain drops
			if (numDrops < maxNumDrops) {
				if (Math.random() > .75) {
					var dropX = Math.random() * (rect.right - rect.left) + rect.left + offsetX;
					var dropY = cloudBottom + offsetY - Math.random() * 60;
					var dropHeight = Math.random() * 20 + 10;
					var drawStr = ['M', dropX, ' ', dropY, 'L', dropX, ' ',  dropY + dropHeight].join();
					var drop = paper.path(drawStr);
					var speeds = Math.random() * 8 + 5;
					drop.attr("stroke-width", 2);
					drop.attr( "stroke", "#7bb2d6" );
					
					rainDropSpeeds.push( speeds );
					rainDrops.push( drop );
					rainDropX.push( dropX );
					rainDropY.push( dropY );
					numDrops++;
				}
			}
			
		}
		
		rainFrame += numFramesToAnimate;
		
		// Move the rain drops
		for (var i = 0; i < numDrops; i++) {
			oldX = rainDropX[i];
			oldY = rainDropY[i];
			rainDropY[i] += rainDropSpeeds[i] * numFramesToAnimate;
			if (rainDropY[i] > waterLevel) {
				rainDropX[i] = Math.random() * (rect.right - rect.left) + rect.left + offsetX;
				rainDropY[i] = cloudBottom + offsetY - Math.random() * 20;
			}
			rainDrops[i].translate( rainDropX[i] - oldX, rainDropY[i] - oldY );
		}
		
		// Move water level up
		if (rainFrame > waterRiseFrame && waterLevel > waterLevelMax) {
			waterLevel += waterRiseSpeed * numFramesToAnimate;
		}
		
		// Move stickman up
		if (rainFrame > swimFrame && cloudStickmanY > waterLevel) {
			var stickmanTransY = (waterRiseSpeed - Math.random() * 5) * numFramesToAnimate;
			cloudStickmanY += stickmanTransY;
			
			// Bob up and down
			if (swimBob <= 0) {
				var newBob = Math.random() * 10;
				swimBob += newBob;
			}
			else if (swimBob > 0) {
				newBob = -Math.random() * 10;
				swimBob += newBob;
			}
			cloudStickman.translateLockedPos(0, stickmanTransY + newBob);
		}
		
		// move cloud left
		if (rect.left + offsetX > 100) {
			this.translate(-10 * numFramesToAnimate, 0);
			this.draw();
		}
		// Move cloud up
		if (waterLevel < cloudBottom + offsetY + 20) {
			this.translate(0, -2 * numFramesToAnimate);
			this.draw();
		}
	}
	
	this.endRain = function() {
		for (var i = 0; i < numDrops; i++) {
			rainDrops[i].remove();
		}
		rainDrops = new Array();
		numDrops = 0;
	}
	
	var findCloudBottom = function( checkDist ) {
		var rowWidths = new Array();
		var widestRowWidth = 0;
		var widestRowIndex = 0;
		var narrowestRowWidth = 1000;
		var narrowestRowIndex = 0;
		var rowNum = 0;
		var rowNodes = new Array();
		
		for (var rowBottom = rect.top + checkDist; rowBottom <= rect.bottom + checkDist; rowBottom += checkDist) {
			var rowTop = rowBottom - checkDist;
			
			var nodesInRow = new Array();
			var rowLine = null;
			// Find nodes in this row
			for (var i in paths) {
				var newNodesInRow = paths[i].getNodesInRow(rowTop, rowBottom);
				
				for (var n in newNodesInRow) {
					nodesInRow.push( newNodesInRow[n] );
					if (rowLine == null) rowLine = new Line( nodesInRow[n].getX() );
					else rowLine.addPoint( nodesInRow[n].getX() );
				}
			}
			// Find the widest row
			if (rowLine != null) {
				var newWidth = rowLine.getLength();
				if (newWidth >= widestRowWidth) {
					widestRowWidth = newWidth;
					widestRowIndex = rowNum;
				}
				if (newWidth < narrowestRowWidth && newWidth > 0) {
					narrowestRowWidth = newWidth;
					narrowestRowIndex = rowNum;
				}
			}
			
			rowWidths.push( newWidth );
			rowNodes.push( nodesInRow );
			
			rowNum ++;
		}
		
		var numRows = rowNum;
		var eggBottomRowIndex = widestRowIndex;
		
		for (i = widestRowIndex; i < numRows; i++) {
			if (rowWidths[i] <= narrowestRowWidth + 10) {
				eggBottomRowIndex = i;
				break;
			}
		}
		

		return (eggBottomRowIndex + 1) * checkDist + offsetY + rect.top;
	}
	
	this.findLadderPoints = function( stickman ) {
		var checkDist = 30;
		var rowLines = new Array();
		var rowNodes = new Array();
		var rowNum = 0;
		var rowNodes = new Array();
		var rowsInGroup = 0;
		var minNumRows = 3;
		var bottomRow = 0;
		var topRow = 0;
		
		// Go from bottom to top
		for (var rowBottom = rect.bottom - checkDist; rowBottom >= rect.top; rowBottom -= checkDist) {
			var rowTop = rowBottom - checkDist;
			
			var nodesInRow = new Array();
			var rowLine = null;
			// Find nodes in this row
			for (var i in paths) {
				var newNodesInRow = paths[i].getNodesInRow(rowTop, rowBottom);
				
				for (var n in newNodesInRow) {
					nodesInRow.push( newNodesInRow[n] );
					if (rowLine == null) rowLine = new Line( nodesInRow[n].getX() );
					else rowLine.addPoint( nodesInRow[n].getX() );
				}
			}
			
			if (nodesInRow.length == 0) {
				// The number of rows must exceed the min rows to be considered a ladder
				if (rowsInGroup >= minNumRows) {
					topRow = rowNum - 1;
				}
				else {
					bottomRow = rowNum + 1;
					rowsInGroup = 0;
				}
			}
			else {
				rowsInGroup += 1;
			}
			
			rowNodes.push( nodesInRow );
			rowLines.push( rowLine );
			
			rowNum ++;
		}
		if (topRow == 0) topRow = rowNum - 1;
		
		if (rowLines[ bottomRow ] == null) {
			bottomPoint = new Point(rect.left, rect.top);
			topPoint = new Point(rect.left, rect.top);
		} else {
			var bottomPoint = new Point( rowLines[ bottomRow ].getCenter(), rect.bottom - checkDist * bottomRow );
			var topPoint = new Point( rowLines[ topRow ].getCenter(), rect.bottom - (checkDist + 1) * topRow );
		}
		
		// Find the stepping points		
		var leftFootPos = stickman.getLeftFootPos();
		var rightFootPos = stickman.getRightFootPos();
		var rightFootOffset = new Point( rightFootPos.x - leftFootPos.x, rightFootPos.y - leftFootPos.y );
		var stepUpDist = stickman.getRect().getHeight() * .2;
		var stepSideDist = stickman.getRect().getWidth() * 2.5;
		
		var leftStepPoints = new Array();
		var rightStepPoints = new Array();
		
		// Find the next closest step
		
		var leftFootPos = bottomPoint;
		//leftStepPoints.push( leftFootPos );
		var steps = 0;
		
		while (leftFootPos.y >= topPoint.y + 20 && steps < 100) {
			// Right foot
			var nextFootTarget = new Point( leftFootPos.x + rightFootOffset.x, leftFootPos.y + rightFootOffset.y - stepUpDist );
			var rightFootPos = this.getNodeClosestToPoint(nextFootTarget, leftFootPos.x + 3, leftFootPos.x + stepSideDist, leftFootPos.y - stepUpDist * 3, leftFootPos.y );
			var foundStep = true;
			if (rightFootPos == null) rightFootPos = new Point( leftFootPos.x + 6, leftFootPos.y );
			
			// Can't find any more steps
			if (prevRightFootPos != null && rightFootPos.x == prevRightFootPos.x && rightFootPos.y == prevRightFootPos.y) break;
			var prevRightFootPos = rightFootPos;
			
			var rightFootDisp = this.adjustPointForScreen( rightFootPos );
			rightStepPoints.push( rightFootDisp );
			//paper.circle(rightFootDisp.x, rightFootDisp.y, 5, 5, 0).attr({'fill':'#f00', opacity:.5});
			
			// Left foot
			var nextFootTarget = new Point( rightFootPos.x - rightFootOffset.x, rightFootPos.y - rightFootOffset.y - stepUpDist );
			var leftFootPos = this.getNodeClosestToPoint(nextFootTarget, rightFootPos.x - stepSideDist, rightFootPos.x - 3, rightFootPos.y - stepUpDist * 3, rightFootPos.y );
			if (leftFootPos == null) {
				leftFootPos = new Point( rightFootPos.x - 6, rightFootPos.y );
				if (foundStep == false) {
					break;
				}
			}
			var leftFootDisp = this.adjustPointForScreen( leftFootPos );
			leftStepPoints.push( leftFootDisp );
			//paper.circle(leftFootDisp.x, leftFootDisp.y, 5, 5, 0).attr({'fill':'#0f0', opacity:.5});
			
			steps += 2;
		}
		
		
		bottomPoint.x += offsetX;
		bottomPoint.y += offsetY;
		topPoint.x += offsetX;
		topPoint.y += offsetY;
		
		var returnObj = new Object();
		returnObj.top = topPoint;
		returnObj.bottom = bottomPoint;
		returnObj.leftFootSteps = leftStepPoints;
		returnObj.rightFootSteps = rightStepPoints;
		
		// Returns the ladder's top point, the ladder's bottom point, and the left and right foot steps.
		return returnObj;
	}
	
	this.findClimbSteps = function( footHolds, destinationPos ) {
		// Find the stepping points		
		var leftFootPos = getLeftFootPos();
		var rightFootPos = getRightFootPos();
		var rightFootOffset = new Point( rightFootPos.x - leftFootPos.x, rightFootPos.y - leftFootPos.y );
		var stepUpDist = rect.getHeight() * .3;
		var stepSideDist = rect.getWidth() * .75;
		var minSideStep = 40;
		if (stepSideDist < minSideStep) stepSideDist = minSideStep;
		
		var leftStepPoints = new Array();
		var rightStepPoints = new Array();
		
		
		var debugDraws = new Array();
		var numFootHolds = footHolds.length;
		for (var i = 0; i < numFootHolds; i++) {
			debugDraws.push( paper.circle(footHolds[i].x, footHolds[i].y, 10, 10, 0).attr({'fill':'#ff0', opacity:.1}) );
		}
		
		
		
		// Find the next closest step
		
		var steps = 0;
		
		var destRange = 10;
		var destRect = new Rectangle( destinationPos.x - destRange, destinationPos.y - destRange, destinationPos.x + destRange, destinationPos.y + destRange );
		while (destRect.isPointWithinRect( leftFootPos.x, leftFootPos.y ) == false && destRect.isPointWithinRect( rightFootPos.x, rightFootPos.y ) == false && steps < 100) {
			// Right foot
			var nextFootTarget = findStepTarget( destinationPos, new Point( rightFootPos.x, rightFootPos.y ), stepUpDist, stepSideDist );

			debugDraws.push( paper.circle(nextFootTarget.x, nextFootTarget.y, 3, 3, 0).attr({'fill':'#f0f', opacity:.4}) );

			var rightFootPos = findFootHoldClosestToPoint(footHolds, rightFootPos, nextFootTarget, leftFootPos.x + 3, rightFootPos.x + stepSideDist * 1.5, rightFootPos.y - stepUpDist * 3, rightFootPos.y + stepUpDist * 3, destinationPos );
			var foundStep = true;
			if (rightFootPos == null) {
				rightFootPos = new Point( nextFootTarget.x, nextFootTarget.y );
			}
			
			// Can't find any more steps so we just create one where we want it.
			if (prevRightFootPos != null && rightFootPos.x == prevRightFootPos.x && rightFootPos.y == prevRightFootPos.y) {
				rightFootPos = nextFootTarget;
			}
			var prevRightFootPos = rightFootPos;
			
			rightStepPoints.push( rightFootPos );
			debugDraws.push( paper.circle(rightFootPos.x, rightFootPos.y, 5, 5, 0).attr({'fill':'#f00', opacity:.4}) );
			
			// Left foot
			nextFootTarget = findStepTarget( destinationPos, new Point( leftFootPos.x, leftFootPos.y ), stepUpDist, stepSideDist );
			debugDraws.push( paper.circle(nextFootTarget.x, nextFootTarget.y, 3, 3, 0).attr({'fill':'#f4f', opacity:.4}) );
			var leftFootPos = findFootHoldClosestToPoint(footHolds, leftFootPos, nextFootTarget, leftFootPos.x - stepSideDist * 1.5, rightFootPos.x - 3, leftFootPos.y - stepUpDist * 3, leftFootPos.y + stepUpDist * 3, destinationPos );
			if (leftFootPos == null) {
				leftFootPos = new Point( nextFootTarget.x, nextFootTarget.y );
				if (foundStep == false) {
					leftFootPos = nextFootTarget;
				}
			}
			leftStepPoints.push( leftFootPos );
			debugDraws.push( paper.circle(leftFootPos.x, leftFootPos.y, 5, 5, 0).attr({'fill':'#0f0', opacity:.4}) );
			
			steps += 2;
		}
		
		var numDebugDraws = debugDraws.length;
		for (var i = 0; i < numDebugDraws; i++) {
			debugDraws[i].remove();
		}
		
		var returnObj = new Object();
		returnObj.leftFootSteps = leftStepPoints;
		returnObj.rightFootSteps = rightStepPoints;
		
		return returnObj;
	}
	
	var findStepTarget = function( destinationPos, footPos, stepUpDist, stepSideDist ) {
		var travelPath = new Point( destinationPos.x - footPos.x, destinationPos.y - footPos.y );
		var targetPos = new Point(0,0);
		// X is larger
//		if (Math.abs( travelPath.x ) > Math.abs( travelPath.y ) ) {
			// X
			if (travelPath.x > 0) {
				targetPos.x = footPos.x + stepSideDist;
				if (targetPos.x > destinationPos.x) targetPos.x = destinationPos.x;
			}
			else {
				targetPos.x = footPos.x - stepSideDist;
				if (targetPos.x < destinationPos.x) targetPos.x = destinationPos.x;
			}

			// Y
//			var stepY = travelPath.y * Math.abs( (targetPos.x - footPos.x) / travelPath.x );
//			if (stepY > stepUpDist) stepY = stepUpDist;
//			else if (stepY < -stepUpDist) stepY = -stepUpDist;
//			targetPos.y = footPos.y + stepY;
//		}
		// Y is larger
//		else {
			// Y
			if (travelPath.y > 0) {
				targetPos.y = footPos.y + stepUpDist;
				if (targetPos.y > destinationPos.y) targetPos.y = destinationPos.y;
			}
			else {
				targetPos.y = footPos.y - stepUpDist;
				if (targetPos.y < destinationPos.y) targetPos.y = destinationPos.y;
			}
			
			
			// X
//			var stepX = travelPath.x * Math.abs( (targetPos.y - footPos.y) / travelPath.y );
//			if (stepX < -stepSideDist) stepX = -stepSideDist;
//			else if (stepX > stepSideDist) stepX = stepSideDist;
//			targetPos.x = footPos.x + stepX;
//		}
		
		return targetPos;
	}

	var findFootHoldClosestToPoint = function( footHolds, prevPos, point, minX, maxX, minY, maxY, destPos ) {
		var closest = null;
		var distX = 0;
		var distY = 0;
		var numHolds = footHolds.length;
		
		// Setup the min and max so that the stickman does not backtrack.
		var travelPath = new Point( destPos.x - prevPos.x, destPos.y - prevPos.y );
		if (Math.abs( travelPath.x ) > 40 || Math.abs( travelPath.y ) > 40) {
			// X is larger
			if (Math.abs( travelPath.x ) > Math.abs( travelPath.y ) ) {
				// X
				if (travelPath.x > 0) {
					if (minX < prevPos.x + 3) minX = prevPos.x + 3;
				}
				else {
					if (maxX > prevPos.x - 3) maxX = prevPos.x - 3;
				}
			}
			// Y is larger
			else {
				// Y
				if (travelPath.y > 0) {
					if (minY < prevPos.y + 3) minY = prevPos.y + 3;
				}
				else {
					if (maxY > prevPos.y + 3) maxY = prevPos.y - 3;
				}
			}
		}
			
		
		for (var i = 0; i < numHolds; i++) {
			if (footHolds[i].x <= maxX && footHolds[i].x >= minX && footHolds[i].y <= maxY && footHolds[i].y >= minY) {
				var newDistX = footHolds[i].x - point.x;
				var newDistY = footHolds[i].y - point.y;
					
				if (Math.abs( newDistX ) + Math.abs( newDistY ) < Math.abs( distX ) + Math.abs( distY ) || closest == null ) {
					distX = newDistX;
					distY = newDistY;
					closest = footHolds[i];
				}
			}
		}
		
		return closest;
	}

	this.getNodeClosestToPoint = function( point, minX, maxX, minY, maxY ) {
		var closest = null;
		var distX = 0;
		var distY = 0;
		
		for (var i = 0; i < numPaths; i++) {
			var newClosest = paths[i].getNodeClosestToPoint( point, minX, maxX, minY, maxY );
			if (newClosest != null) {
				var newDistX = newClosest.x - point.x;
				var newDistY = newClosest.y - point.y;
				
				if (Math.abs( newDistX ) + Math.abs( newDistY ) < Math.abs( distX ) + Math.abs( distY ) || closest == null ) {
					distX = newDistX;
					distY = newDistY;
					closest = newClosest;
				}
			}
		}
		
		return closest;
	}

	this.getRect = function() {
		return rect;
	}
	var getRightFootPos = this.getRightFootPos = function() {
		return adjustPointForScreen( new Point( rightFootNode.getX(), rightFootNode.getY() ) );
	}
	var getLeftFootPos = this.getLeftFootPos = function() {
		return adjustPointForScreen( new Point( leftFootNode.getX(), leftFootNode.getY() ) );
		//var point = this.adjustPointForScreen( new Point( leftFootNode.getX(), leftFootNode.getY() ) );
		//paper.circle(point.x, point.y, 5, 5, 0).attr({'fill':'#0ff', opacity:.5});
		//return point;
	}
	this.getLeftFootPosX = function() {
		return adjustPointForScreen( new Point( leftFootNode.getX(), leftFootNode.getY() ) ).x;
	}
	this.getLeftFootPosY = function() {
		return adjustPointForScreen( new Point( leftFootNode.getX(), leftFootNode.getY() ) ).y;
	}
	
	// Pass us a point relative to the path group and we return the point relative to the screen.
	this.adjustPointForScreen = function( point ) {
		return new Point( ( point.x  + offsetX ) * zoomScaleX + zoomX, ( point.y + offsetY ) * zoomScaleY + zoomY);
	}
	var adjustPointForScreen = this.adjustPointForScreen;
	// Pass us a point relative to the screen and we return the point relative to the path group.
	var adjustPointForPathGroup = this.adjustPointForPathGroup = function( point ) {
		//return new Point( (point.x - offsetX) / zoomScaleX - zoomX, (point.y - offsetY) / zoomScaleY - zoomY);
		return new Point( (point.x - zoomX) / zoomScaleX - offsetX, (point.y - zoomY) / zoomScaleY - offsetY);
	}

	
	this.getDataForJSON = function() {
		//var groupData = new Object();
		
		// Save paths
		var pathData = new Array();
		for (var i = 0; i < numPaths; i++) {
			var nodeArray = paths[i].getDataForJSON();
			if (nodeArray.length > 0) pathData.push( nodeArray );
		}
//		groupData.p = pathData;
//		groupData.n = numPaths;
		
		// Save rect
//		groupData.rect = new Array(rect.left, rect.top, rect.right, rect.bottom );
		
		return pathData;
	}
	
	this.setDataFromJSON = function( groupData, color, strokeWidth, flip ) {		
		// Load paths
		var numPathData = groupData.length;
		for (var i = 0; i < numPathData; i++) {
			var path = new Path( paper, color, strokeWidth, zoomCont );
			path.setDataFromJSON( groupData[i], flip );
			addPath( path );
			//paths[i] = path;
		}
		
		// Load rect
//		if (flip == true) {
//			rect = new Rectangle( -groupData.rect[2], groupData.rect[1], -groupData.rect[0], groupData.rect[3] );
//		}
//		else rect = new Rectangle( groupData.rect[0], groupData.rect[1], groupData.rect[2], groupData.rect[3] );
		
		distortion = new Distortion( rect );
	}
	
	this.redrawSlowly = function( _doneDrawingFunction ) {
		lastSlowPathDrawn = 0;
		doneDrawingFunction = _doneDrawingFunction;
		paths[lastSlowPathDrawn].redrawSlowly( drawNextPathSlowly, offsetX, offsetY );
	}
	
	var drawNextPathSlowly = function() {
		lastSlowPathDrawn ++;
		if (lastSlowPathDrawn >= numPaths) {
			doneDrawingFunction();
		}
		else paths[lastSlowPathDrawn].redrawSlowly( drawNextPathSlowly, offsetX, offsetY );
	}
	
	this.copyToAnotherPathGroup = function( pathGroup, color, strokeWidth ) {
		for (var i = 0; i < numPaths; i++) {
			var nodes = paths[i].getNodes();
			var numNodes = nodes.length;
			var points = new Array();
			for (var n = 0; n < numNodes; n++) {
				points[n] = adjustPointForScreen( new Point( nodes[n].getX(), nodes[n].getY() ) );
			}
			pathGroup.addExternalPath( points, color, strokeWidth );
		}
	}

	this.addExternalPath = function( pathPoints, color, strokeWidth ) {
		var path = new Path( paper, color, strokeWidth, zoomCont );
		var numPathPoints = pathPoints.length;
		for (var i = 0; i < numPathPoints; i++ ) {
			var pointLocal = adjustPointForPathGroup( pathPoints[i] );
			path.createQuickNode( pointLocal.x, pointLocal.y );
		}
		path.finalizePath();
		path.setScale( zoomX, zoomY, zoomScaleX, zoomScaleY );
		paths.push( path );
		externalPaths.push( path );
		numPaths ++;
		numExternalPaths ++;
	}
	
	this.startCostumeFall = function( _hatFallSpeedX, _hatFallSpeedY, _hatGravity, _hatDestinationY, _hatAnimFinishedFunction ) {
		hatFallSpeedX = _hatFallSpeedX;
		hatFallSpeedY = _hatFallSpeedY;
		hatDestinationY = _hatDestinationY;
		hatGravity = _hatGravity;
		hatAnimFinishedFunction = _hatAnimFinishedFunction;
		var minHat = 30;
		var hatHeight = rect.getHeight() * .3;
		if (hatHeight < minHat) hatHeight = minHat;
		var hatBottom = rect.top + hatHeight;
		hatTop = rect.top;
		hatPaths = new Array();
		numHatPaths = 0;
		
		// Find a path in the external paths
		for (var i = 0; i < numExternalPaths; i++) {
//			var rectTest = externalPaths[i].getRect();
//			if (externalPaths[i].getRect().top <= hatBottom) {
				hatPaths.push( externalPaths[i] );
				numHatPaths++;
//			}
		}
	}
	
	this.updateCostumeFall = function( numPasses ) {
		var moveDistX = 0;
		var moveDistY = 0;
		for (var i = 1; i <= numPasses; i++) {
			hatFallSpeedY += hatGravity;
			hatTop += hatFallSpeedY;
			moveDistX += hatFallSpeedX;
			moveDistY += hatFallSpeedY;
		}
		
		for (var i = 0; i < numHatPaths; i++) {
			hatPaths[i].move( moveDistX, moveDistY );
		}
		if (hatTop >= hatDestinationY) {
			for (var i = 0; i < numHatPaths; i++) {
				hatPaths[i].clearDisplay();
				hatPaths[i].deleteNodes();
			}
			hatAnimFinishedFunction();
		}
	}
	
	var sendToBack = this.sendToBack = function() {
		alwayAtBack = true;
		for (var i = 0; i < numPaths; i++) {
			paths[i].sendToBack();
		}
	}
	
	this.getScaleX = function() {
		return zoomScaleX;
	}
	this.getScaleY = function() {
		return zoomScaleY;
	}
	
	// Returns all the paths as a set
	this.getGroupSet = function() {
		var st = paper.set();
		for (var i = 0; i < numPaths; i++) {
			var lineOnScreen = paths[i].getLineOnScreen();
			st.push( lineOnScreen );
		}
		return st;
	}

	this.fitToRect = function( fitRect, scaleStroke ) {
		var sizeScale = fitRect.getWidth() / rect.getWidth();
		if (rect.getHeight() * sizeScale > fitRect.getHeight()) {
			sizeScale = fitRect.getHeight() / rect.getHeight();
		}
		var targetPosX = (fitRect.left + fitRect.getWidth() / 2) - (rect.getWidth() * sizeScale) / 2;
		var targetPosY = (fitRect.top + fitRect.getHeight() / 2) - (rect.getHeight() * sizeScale) / 2;
		
		var newZoomX = targetPosX - rect.left * sizeScale;
		var newZoomY = targetPosY - rect.top * sizeScale;
		
		try {
			setScale( newZoomX, newZoomY, sizeScale, sizeScale );
		}
		catch (e) {
			alert(e);
		}
		if (scaleStroke == true) {
			for (var i = 0; i < numPaths; i++) {
				paths[i].scaleStrokeWidth( sizeScale );
			}
		}
	}
	
	this.getPrintExportData = function( fitRect, strokeWidth, strokeColor ) {
		var sizeScale = fitRect.getWidth() / rect.getWidth();
		if (rect.getHeight() * sizeScale > fitRect.getHeight()) {
			sizeScale = fitRect.getHeight() / rect.getHeight();
		}
		var targetPosX = (fitRect.left + fitRect.getWidth() / 2) - (rect.getWidth() * sizeScale) / 2;
		var targetPosY = (fitRect.top + fitRect.getHeight() / 2) - (rect.getHeight() * sizeScale) / 2;
		
		var newZoomX = targetPosX - rect.left * sizeScale;
		var newZoomY = targetPosY - rect.top * sizeScale;
		
		var exportData = "";
		for (var i = 0; i < numPaths; i++) {
			exportData += paths[i].getPrintExportData( sizeScale, newZoomX, newZoomY ) + ";";
		}
		exportData = ( Math.round( strokeWidth * sizeScale) ) + "|" + strokeColor + "|" + exportData;
		var numChars = exportData.length;
		exportData = "" + numChars + "|" + exportData;
		
		return exportData;
	}

	this.cleanUp = function() {
		for (var i = 0; i < numPaths; i++) {
			paths[i].cleanUp();
		}
		paths = null;
		paper = null;
		lineOnScreen = null;
		rect = null;
		distortion = null;
		leftFootNode = null;
		rightFootNode = null;
		offsetX = null;
		offsetY = null;
		lockedX = null;
		lockedY = null;
		lockedNode = null;
		headPos = null;
		feetPos = null;
		numPaths = null;
		heldItems = null;
		heldItemPos = null;
		numHeldItems = null;
		zoomX = null;
		zoomY = null;
		zoomScaleX = null;
		zoomScaleY = null;
		pathGroupObj = null;
		eggSpeedY = null;
		eggGravity = null;
		eggBottomY = null;
		eggGround = null;
		eggNodes = null;
		numEggNodes = null;
		eggRowNodes = null;
		eggRowHeight = null;
		lastDeleteRow = null;
		rainDropSpeeds = null;
		rainDrops = null;
		rainDropX = null;
		rainDropY = null;
		numDrops = null;
		waterLevel = null;
		maxNumDrops = null;
		rainFrame = null;
		waterRiseSpeed = null;
		waterRiseFrame = null;
		cloudStickman = null;
		cloudStickmanY = null;
		waterLevelMax = null;
		swimFrame = null;
		swimBob = null;
		cloudBottom = null;
		lastSlowPathDrawn = null;
		doneDrawingFunction = null;
		hatFallSpeedX = null;
		hatFallSpeedY = null;
		hatDestinationY = null;
		hatGravity = null;
		hatAnimFinishedFunction = null;
		hatTop = null;
		hatPaths = null;
		numHatPaths = null;
		externalPaths = null;
		numExternalPaths = null;
		alwayAtBack = null;
		zoomCont = null;
	}
}