function ZoomControl( _framesX, _framesY, _framesScale, _animFrames, _numFrames, _xmlAnim) {
	var framesX = _framesX;
	var framesY = _framesY;
	var framesScale = _framesScale;
	var xmlAnim = _xmlAnim;
	var scale = 1;
	var offsetX = 0;
	var offsetY = 0;
	var curFrame = 0;
	var numFrames = _numFrames;
	var animPaused = false;
	var animFrames = _animFrames;
	
	this.animateFrame = function( numFramesToAnimate ){
		var animated = false;
		for (var i = 0; i < numFramesToAnimate; i++) {
			if (curFrame > numFrames || animPaused == true) {
			
			}
			else {
				if (animFrames[curFrame] != true) {
					curFrame ++;
				}
				else {			
					if (framesX[curFrame] != null) offsetX = -framesX[curFrame];
					if (framesY[curFrame] != null) offsetY = -framesY[curFrame];
					if (framesScale[curFrame] != null) scale = 1 / framesScale[curFrame];
					
					curFrame ++;
					animated = true;
				}
			}
		}
		
		return animated;
	}

	
	this.zoomX = function( posX ) {
		return (posX + offsetX) * scale;
	}
	this.zoomY = function( posY ) {
		return (posY + offsetY) * scale;
	}
	this.zoomSize = function( size ) {
		return size * scale;
	}
	
	this.unzoomX = function( posX ) {
		return posX / scale - offsetX;
	}
	this.unzoomY = function( posY ) {
		return posY / scale - offsetY;
	}
	this.unzoomSize = function( size ) {
		return size / scale;
	}
	
	this.pauseAnimation = function(){
		animPaused = true;
	}
	this.resumeAnimation = function(){
		animPaused = false;
	}
}